;
;     NEWCURS() - draw a new cursor
;
;     Syntax: NEWCURS(<top scan line>, <bottom scan line>)
;
;     Assembled with Microsoft MASM 4.0
;
;     Written by Greg Lief 03/03/89
;

  INCLUDE \CLIPPER\EXTENDA.INC

  Name                 CURSNEW
  Public               NEWCURS
  Extrn                __ParNI:Far
  Extrn                __ret:far

  DGROUP GROUP         datasg                                  
  datasg segment       public '_DATA'

  Cursor_top           db         ?
  Cursor_bottom        db         ?

  datasg               ends

  _Prog                Segment  'CODE'
                       Assume     CS:_Prog,DS:DGROUP,ES:DGROUP


  NEWCURS              Proc       Far
                       Push       BP                             ; Save stack
                       Mov        BP,SP
                       Push       DS
                       Push       ES
                       Push       SI
                       Push       DI

                       Mov        AX,01                          ; First parameter
                       Push       AX
                       Call       __PARNI                         ; Get Upper Left Row
                       Add        SP,2                           ; Fix up stack
                       Mov        Cursor_top,AL                  ; Save Value

                       Mov        AX,02                          ; Second parameter
                       Push       AX
                       Call       __PARNI                         ; Get Upper Left Column
                       Add        SP,2                           ; Fix up stack
                       Mov        Cursor_bottom,AL               ; Save Value

                       MOV        CH, Cursor_top
                       MOV        CL, Cursor_bottom
                       mov        ah,01
                       int        10h
                       Pop        DI
                       Pop        SI
                       Pop        ES
                       Pop        DS
                       Pop        BP
                       call       __ret
                       Ret

  NEWCURS              Endp
  _Prog                Ends
                       End
