#include "D:\CL52\INCLUDE\CLIPDEFS.H"
#include "D:\CL52\INCLUDE\EXTEND.API"
#include "D:\CL52\INCLUDE\FM.API"

#ifdef CLIPPER52
#include "D:\CL52\INCLUDE\FILESYS.API"
#else
typedef HANDLE FHANDLE;

FHANDLE cdecl _tOpen( BYTEP filename, USHORT flags );
void    cdecl _tClose( FHANDLE h );
USHORT  cdecl _tRead( FHANDLE h, BYTEP buff, USHORT count );
USHORT  cdecl _tWrite( FHANDLE h, BYTEP buff, USHORT count );

#define _fsOpen( n, f )       _tOpen( n, f )
#define _fsClose( h )         _tClose( h )
#define _fsRead( h, b, c )    _tRead( h, b, c )
#define _fsWrite( h, b, c )   _tWrite( h, b, c )
#endif

void cdecl _evLow( unsigned int, ... );

static HANDLE hSource;
static HANDLE hTarget;
static unsigned int nBufSize;
static unsigned int lPrint;
static BYTEP pBuffer;

static void cdecl Print( void )
{
   auto unsigned int nBytes;

   if ( nBytes = _fsRead( hSource, pBuffer, nBufSize ) )
      _fsWrite( hTarget, pBuffer, nBytes );
   else
   {
      _evLow( 5, Print, FALSE );

      _fsClose( hSource );
      _fsClose( hTarget );

      _xfree( pBuffer );

      lPrint = 0;
   }

   return;
}



CLIPPER BackPrint( void )
{
   if ( lPrint )
   {
      error : _retl( FALSE );
      return;
   }

   if ( ( hSource = _fsOpen( _parc( 1 ), 0 ) ) == -1 ) goto error;

   if ( ( hTarget = _fsOpen( _parc( 2 ), 1 ) ) == -1 )
   {
      _fsClose( hSource );
      
      goto error;
   }

   pBuffer = _xgrab( nBufSize = _parni( 3 ) );

   lPrint = 1;

   _evLow( 5, Print, TRUE );

   _retl( TRUE );

   return;
}



CLIPPER isPrinting( void )
{
   _retl( lPrint );

   return;
}

