; This was extracted from CLIPPER.LIB and disassembled with the WatCom
; disassembler.  A call to the mouse cleanup function was added to the
; _TERM function so that mouse deinitialization could occur transparently
; upon program exit.
;
; This could have been handled better with an EXIT proc, but Clipper 5.01
; doesn't support them.  Thus a more generic solution was required.
;

                NAME    MAIN
                EXTRN   __appMain:BYTE
                EXTRN   __sysPostArgs:BYTE
                EXTRN   __sysErrorLevel:BYTE
                EXTRN   __sysExit:BYTE
                EXTRN   __sysInit:BYTE
                EXTRN   __exit:BYTE
                EXTRN   __errmsg:BYTE
                EXTRN   __acrtused:BYTE

                Extrn   __gfmExit:Far           ; Added by TDM

DGROUP          GROUP   CONST,_BSS,_DATA
MAIN_TEXT       SEGMENT WORD PUBLIC 'CODE'
                ASSUME  CS:MAIN_TEXT,DS:DGROUP,SS:DGROUP
                PUBLIC  _term
                PUBLIC  _main
_term:          push    BP
                mov     BP,SP
                
                Call    __gfmExit               ; Added by TDM

                push    word ptr [BP+6H]
                call    far ptr __sysExit
                add     SP,0002H
                or      AX,AX
                je      short L1
                mov     AX,0001H
                push    AX
                call    far ptr __exit
                add     SP,0002H
L1:             call    far ptr __sysErrorLevel
                push    AX
                call    far ptr __exit
                add     SP,0002H
                pop     BP
                retf    
_main:          push    BP
                mov     BP,SP
                sub     SP,0002H
                push    word ptr [BP+0aH]
                push    word ptr [BP+8H]
                push    word ptr [BP+6H]
                call    far ptr __sysPostArgs
                add     SP,0006H
                sub     AX,AX
                push    AX
                call    far ptr __sysInit
                add     SP,0002H
                mov     word ptr [BP-2H],AX
                or      AX,AX
                je      short L2
                mov     AX,offset L4
                push    CS
                push    AX
                call    far ptr __errmsg
                add     SP,0004H
                jmp     short L3
L2:             call    far ptr __appMain
                mov     word ptr [BP-2H],AX
L3:             push    word ptr [BP-2H]
                push    CS
                call    near ptr _term
                mov     AX,0001H
                mov     SP,BP
                pop     BP
                retf

; This was moved from the data segment to avoid DGROUP consumption

L4              LABEL   BYTE
                DB      0dH,0aH,0dH,0aH,49H,6eH,69H,74H
                DB      69H,61H,6cH,69H,7aH,61H,74H,69H
                DB      6fH,6eH,20H,65H,72H,72H,6fH,72H
                DB      73H,0dH,0aH,00H
MAIN_TEXT       ENDS

CONST           SEGMENT WORD PUBLIC 'CONST'
CONST           ENDS

_BSS            SEGMENT WORD PUBLIC 'BSS'
_BSS            ENDS

_DATA           SEGMENT WORD PUBLIC 'DATA'
                PUBLIC  C50R100
                PUBLIC  CLIPPER501
C50R100         LABEL   BYTE
                DB      00H,00H
CLIPPER501      LABEL   BYTE
                DB      00H,00H
_DATA           ENDS

                END

