*!*********************************************************************
*!
*!      Procedure: CHECKAPPTS
*!
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 09/05/89     10:02
*:
*:          Calls: POPDATE.PRG
*:
*:           Uses: APPT.DBF
*:
*:        Indexes: APPT.NTX
*!
*!*********************************************************************
PROCEDURE checkappts
PRIVATE wk_area, prevcolor, prevscr, curstop, cursbot, mdate, mfile
curstop = curs_top()            && get the current cursor starting scan line
cursbot = curs_bot()            && get the current cursor ending scan line
wk_area = SELECT()              && save current work area
newcurs(32, 0)                  && equivalent of SET CURSOR OFF
mdate = DATE()
SELECT 0
mfile = IF(TYPE('apptdir') != 'U', apptdir + '\', '') + 'appt'
IF FILE(mfile + '.dbf') .AND. FILE(mfile + '.dbt') .AND. FILE(mfile + 'date.ntx')
   USE (mfile) INDEX (mfile + 'date')
   SEEK DTOS(mdate)
   IF FOUND()
      prevcolor = SETCOLOR()            && save previous color setting
      SETCOLOR('W/RB')
      prevscr = Exbox(10,24,14,55,5,0,'',.T.)
      TONE(800,1)
      TONE(1000,1)
      SETCOLOR('*W+/RB')
      @ 11,26 SAY 'You have appointments today!'
      SETCOLOR('+W/RB')
      @ 12,26 SAY 'Press F2 to check calendar,'
      @ 13,26 SAY 'or any other key to proceed'
      INKEY(0)
      ByeByeBox(prevscr)
      SETCOLOR(prevcolor)
      IF LASTKEY() = -1
         USE
         DO POPDATE
      ENDIF
   ENDIF
ENDIF
USE
SELECT(wk_area)
newcurs(curstop, cursbot)       && restore previous cursor
RETURN

* eof chk_appt.prg
