*
* DEMO.prg
* Grumpfish Library Version 3.0 comprehensive demo
* Finalized 10.17.90 by Greg Lief
* Copyright (c) 1990 Greg Lief
* for prospective customers
*

parameter skip_it
skip_it = if(type('skip_it') != 'L', .f., skip_it)
EXTERNAL soundex, helpdev
SET KEY 28 TO helpdev
PRIVATE start_time, thepalette, screens[9], mfile
SET CURSOR OFF
SET SCOREBOARD OFF
SET WRAP ON
waitoff()
mfile = '!!!!!!!!.!!!'
SAVE_DRAPE(mfile)
selected = 'i'
maincolor = IF(Iscolor(), 'w/b', 'w/n')
if ! skip_it
   SETCOLOR('+W/N')
   CLEAR
   mstring = 'The Grumpfish Library'
   fallguy(03, 29, mstring, 100)
   SETCOLOR('+BR/N')
   CENTER(24, 'Press space bar for demo or Esc for DOS')
   rainbow(mstring)
   IF LASTKEY() != 27
      lets_go()
   ENDIF
else
   lets_go()
endif
SETCOLOR('I')
@ 0,0,24,79 box REPLICATE(CHR(250),9)
SETCOLOR('W/BR')
expbox(1, 6, 23, 73, 1, 30, '', 'temparray')
SETCOLOR('+W/BR')
rollup("Grumpfish Library is written 99.9% in Clipper.  You get two")
rollup("versions of the source code: one for Summer '87, and another")
rollup("FULLY OPTIMIZED for Clipper 5.0.  You also get a no-nonsense")
rollup("royalty-free integration license, easy-to-read documentation,")
rollup("one year free BBS technical support on the Grumpfish BBS (a")
rollup("worldwide haven for Clipper expertise), and thirty days free")
rollup("voice support.  Our '                   ' guarantee: if you are")
rollup("not absolutely tickled pink by Grumpfish, return it within 30")
rollup("days from your date of purchase for a full and courteous refund!")
rollup('')
rollup('Grumpfish Library is available for just $199 (shipping: $7.50')
rollup("US/Canada, $20 overseas).  Order NOW by calling (503) 588-1815")
rollup("or fax your order to (503) 588-1980.  MC/VISA/AMEX accepted.")
rollup('')
rollup(SPACE(20) + 'Grumpfish, Incorporated')
rollup(SPACE(20) + 'Post Office Box 17761')
rollup(SPACE(20) + 'Salem, Oregon 97305 USA')
rollup('')
rollup("")
rollup("Tel 0268 590955         Tel 93 16 09 12         Tel 089 570 6031")
rollup("Fax 0268 590005         Fax 93 88 08 90         Fax 089 570 7631")
SETCOLOR('+GR/BR')
@ 4,8 SAY 'FULLY OPTIMIZED'
@ 8,29 SAY 'No Grumpy Customers'
@ 13,56 say "(503) 588-1815"
@ 14,29 say "(503) 588-1980"
SETCOLOR('I')
@ 20,8 say "United Kingdom"
@ 20,37 say "France"
@ 20,60 say "Germany"
INKEY(20)
impbox(temparray, 60)
ERASE help.dbf
ERASE help.cfg
ERASE help.dbt
ERASE help.ntx
ERASE demo2.scr
ERASE demo3.scr
ERASE demo.scr
SET COLOR TO
any_key='fadeback.scr'
IF FILE(any_key)
   FADEIN(any_key)
ELSE
   BLINDOPEN(mfile)
ENDIF
ERASE (mfile)
set cursor on
@ 24,0 SAY ''
QUIT

PROCEDURE lets_go
PRIVATE any_key, mfile, mmenu[13]
mmenu[1] = 'Calculator'
mmenu[2] = 'Notepad'
mmenu[3] = 'Phone Directory'
mmenu[4] = 'Appointments'
mmenu[5] = 'Stop Watch'
mmenu[6] = 'Query Builder'
mmenu[7] = 'GrumpBrowse()'
mmenu[8] = 'Box Functions'
mmenu[9] = 'String Tricks'
mmenu[10] = 'Screen Tricks'
mmenu[11] = 'User Feedback'
mmenu[12] = 'Color Palette'
mmenu[13] = 'Exit'
SETCOLOR(maincolor)
@ 0,0,24,79 box REPLICATE(CHR(250),9)
SETCOLOR('+W/R')
Shadowbox(0,0,4,16,6)
@ 1,1 SAY 'Press F1 to'
@ 2,1 SAY 'make your own'
@ 3,1 SAY 'help screen!'
DO WHILE .T.
   sel = menuv(mmenu, 'Main Menu', 11, '+w/b', '+w/r')
   IF ! FILE('demo.scr')
      SAVE_DRAPE('demo.scr')
   ENDIF
   mainmenu = savescreen(0, 0, 24, 79)
   DO CASE
   CASE sel = 1
      do popcalc
   CASE sel = 2
      IF ! FILE('phone.dbf')
         Err_msg("Select the phone directory first!")
      ELSE
         USE phone
         DO popnote
         USE
      ENDIF
   CASE sel = 3
      setcolor(maincolor)
      buff = savescreen(0,0,24,79)
      @ 0,0,24,79 box REPLICATE(CHR(250),9)
      do popphone
      restscreen(0,0,24,79)
   CASE sel = 4
      setcolor("I")
      buff = savescreen(0,0,24,79)
      @ 0,0,24,79 box REPLICATE(CHR(250),9)
      do popdate
      restscreen(0,0,24,79)
   CASE sel = 5
      do popstop
   CASE sel = 6 .or. sel = 7
      IF ! FILE('phone.dbf') .OR. ! FILE('phone.ntx')
         Err_msg("Select the phone directory first!")
      else
         USE phone INDEX phone
         setcolor(maincolor)
         if sel = 6
            Setfilt()
         else
            grumpbrow('aedvqsp')
         endif
         CLOSE data
      endif
   CASE sel = 8
      any_key = 'Exploding Box'
      SETCOLOR(maincolor)
      CLEAR
      SETCOLOR('+w/rb')
      Exbox(07, 01, 14, 60, 2, 5, '', .F., any_key)
      INKEY(.4)
      SETCOLOR('+w/r')
      Exbox(18, 10, 23, 50, 4, 6, '', .F., any_key+' 2', .T.)
      INKEY(.4)
      SETCOLOR('+gr/n')
      Exbox(00, 00, 4, 36, 2, 5, '', .F., any_key+' 3')
      INKEY(.4)
      SETCOLOR('n/gr')
      Exbox(12, 65, 22, 78, 3, 3, '', .F., 'Box #4', .T.)
      INKEY(.4)
      SETCOLOR('+w/g')
      Exbox(01, 45, 04, 78, 1, 11, '', .F., 'Yet Another '+any_key)
      INKEY(2.5)
      Shrbox(01, 45, 04, 78, 5, maincolor)
      INKEY(.3)
      Shrbox(12, 65, 22, 78, 5, maincolor)
      INKEY(.3)
      Shrbox(00, 00, 4, 36, 5, maincolor)
      INKEY(.3)
      Shrbox(18, 10, 23, 50, 5, maincolor)
      INKEY(.3)
      Shrbox(07, 01, 14, 60, 5, maincolor)
      INKEY(1)
      *** note the use of the return value and BYEBYEBOX()
      SETCOLOR('n/bg')
      screens[1] = Popbox(00, 00, 22, 40, 2, 18, .F., 'Pop-up Box 1')
      INKEY(.35)
      SETCOLOR('+gr/n')
      screens[2] = Dropbox(00, 55, 18, 79, 1, 25, .F., 'Pull-down Box 1', .T.)
      INKEY(.35)
      SETCOLOR('n/gr')
      screens[3] = Popbox(03, 44, 20, 70, 5, 20, .F., 'Pop-up Box 2')
      INKEY(.35)
      SETCOLOR('n/w')
      screens[4] = Dropbox(04, 38, 13, 60, 4, 25, .F., 'Pull-down Box 2')
      INKEY(.35)
      SETCOLOR('+w/r')
      screens[5] = Popbox(12, 30, 23, 55, 2, 20, .F., 'Pop-up Box 3', .T.)
      INKEY(.35)
      SETCOLOR('+w/b')
      screens[6] = Popbox(03, 05, 20, 29, 2, 18, .F., 'Another Pop-up')
      INKEY(.35)
      SETCOLOR('n/g')
      screens[7] = Dropbox(06, 28, 20, 66, 1, 12, .T., 'Another Pull-down Box')
      INKEY(.35)
      SETCOLOR('n/r')
      screens[8] = Popbox(02, 15, 17, 45, 1, 10, .T., 'Pop-up Box w/ Crossbar', .T.)
      INKEY(.35)
      SETCOLOR('+w/rb')
      screens[9] = Shadowbox(09, 20, 14, 50, 2, 'Shadow Box', .T.)
      INKEY(1)
      FOR xx = 9 TO 1 STEP -1
         ByeByeBox(screens[xx])
         INKEY(.12)
      NEXT

   CASE sel = 9
      SETCOLOR(maincolor)
      CLEAR
      SETCOLOR('+w/bg')
      Exbox(9, 07, 15, 71, 1, 5, '', .T., 'Silly Strings')
      SPREAD('It is a snap to display character strings from the middle out',10,25)
      SPREAD('as we are demonstrating here. You may also wish to use either',11,25)
      SPREAD('of the two teletype functions, which continuously scroll your',12,25)
      SPREAD('message across a specified row.   Perhaps you already saw the',13,25)
      SPREAD('falling string trick, but in case you missed it,             ',14,25)
      INKEY(4)
      FallGuy(14,58,'here it is!!')
      SETCOLOR(maincolor)
      INKEY(1)
      TTY(20, 'Copyright (C) 1989 Greg Lief', 35, 24)
      TTY2(24, 'Press any key to return to the main menu', 0, maincolor)

   CASE sel = 10
      SETCOLOR('W/N')
      FOR xx = 1 TO 9
         CLRSCR(xx)
         INKEY(.2)
         IF xx < 9
            RESTSCREEN(0, 0, 24, 79, mainmenu)
         ENDIF
         INKEY(.2)
      NEXT
      INKEY(1.5)
      mfile = 'DEMO3.SCR'
      PULL_DRAPE('demo.scr')
      INKEY(2)
      CLEAR
      INKEY(1)
      BLINDOPEN('demo.scr')
      HBLINDSAVE(mfile)
      INKEY(1)
      BLINDCLOSE()
      INKEY(2)
      HBLINDOPEN(mfile)
      INKEY(2)
      HBLINDCLOS()
      INKEY(2)
      IF FILE("FADEIN.SCR")
         FADEIN("FADEIN.SCR")
         INKEY(2)
      ENDIF
      IF FILE("FADEOUT.SCR")
         FADEOUT("FADEOUT.SCR")
         INKEY(2)
      ENDIF
      FOR xx = 0 TO 24
         @ xx, 0 SAY REPLICATE(CHR(xx), 80)
      NEXT
      dumbo = SAVESCREEN(0, 0, 24, 79)
      HSCRNSCRL('demo.scr')
      INKEY(2)
      RESTSCREEN(0, 0, 24, 79, dumbo)
      RELEASE dumbo
      INKEY(2)
      VSCRNSCRL(mfile)
      INKEY(2)

   CASE sel=11
      SETCOLOR(maincolor)
      @ 0,0,24,79 box REPLICATE(CHR(250),9)
      SETCOLOR('+W/BG')
      Expbox(9, 10, 15, 68, 1, 60, '', 'temparray', 'User Feedback')
      SPREAD('The Grumpfish Library includes many user feedback items.',10,20)
      SPREAD('There are functions for yes/no prompts, printer status, ',11,20)
      SPREAD('error messages, wait messages, index status graph, state',12,20)
      SPREAD("validation, and a sleek ACHOICE() replacement.  We will ",13,20)
      SPREAD("start out with the index graph function, IndexBar().... ",14,20)
      INKEY(5)
      ImpBox(temparray, 60)
      create dummy
      append blank
      replace field_name with 'lastname', field_type with 'C', field_len with 30
      create gftemp from dummy
      use gftemp
      waiton("Preparing temporary file... please wait")
      for x = 1 to 1000
         append blank
         replace lastname with chr(gfrand(100) + 65)
      next
      waitoff()
      indexbar('lastname')
      inkey(2)
      indexbar('lastname','lastname', 9, .t.)
      inkey(1)
      use
      erase dummy.dbf
      erase gftemp.dbf
      erase lastname.ntx
      firstans = YES_NO('This is one of the two Grumpfish yes/no prompts',;
                        'Want to see the other one')
      IF ! firstans
         Err_Msg("Too bad, you're going to see it anyway")
      ENDIF
      zapit = yes_no2('Shall we zap the database now?', 12, ' OK ', ' Cancel ', .F.)
      firstans = yes_no2('Send the report to:', 12, ' Printer ', ' File ')
      IF ! firstans
         waiton("Well, let's assume that we are printing now")
         INKEY(2)
         waitoff()
      ENDIF

      inkey(1)
      if ISPRINTER()
         waiton('Please turn off your printer for this demo')
         DO WHILE ISPRINTER()
         ENDDO
         waitoff()
      endif
      printok()
      SET DEVICE TO SCREEN
      Err_msg('This is the error message function!')
      @ 0,0,24,79 box REPLICATE(CHR(250),9)
      SETCOLOR('+w/rb')
      dumbo = Exbox(11, 19, 13, 59, 1, 5, '', .T., 'GETDATE()')
      SPREAD('Get dates the easy way with GetDate()', 12, 20)
      INKEY(2)
      Spread('You selected ' + DTOC(GetDate(DATE(), 0, 56)), 13, 20)
      INKEY(3)
      byebyebox(dumbo)
      dumbo = Exbox(10, 15, 14, 64, 1, 5, '', .T., 'Validation')
      SPREAD('Grumpfish Library offers validation routines for',11,21)
      SPREAD('state abbreviations and Canadian postal codes...',12,21)
      mstate = space(2)
      @ 13, 21 say "Enter a state abbreviation now:" get mstate valid isstate(@mstate)
      set cursor on
      read
      set cursor off
      @ 13, 53 say mstate  && Summer '87 doesn't automatically refresh
      inkey(2)
      byebyebox(dumbo)
      dumbo = Exbox(10, 20, 13, 58, 1, 5, '', .T., 'APICK()')
      SPREAD('This is an example of APICK() - the',11,20)
      SPREAD('Grumpfish enhancement for ACHOICE()',12,20)
      INKEY(4)
      byebyebox(dumbo)
      num_files = ADIR("*.*")
      PRIVATE thefiles[num_files]
      ADIR('*.*', thefiles)
      SETCOLOR('+W/BG')
      sel = APICK(9, 33, 15, 46, thefiles)
      IF sel > 0
         Spread('You selected ' + thefiles[sel], 15, 20)
         INKEY(3)
      ENDIF
      SETCOLOR('+W/R')
      dumbo = Exbox(9, 13, 16, 66, 1, 5, '', .T., 'APICK()')
      SPREAD('Grumpfish has two handy PICTURE clause functions...', 10, 20)
      SPREAD('UP_N_DOWN() converts character input to proper case', 11, 20)
      SPREAD('(upper and lower case) while it is being entered.  ', 12, 20)
      SPREAD('CALC_PIC() simulates calculator-style data entry.  ', 13, 20)
      mvar = space(24)
      set cursor on
      @ 14, 14 SAY "UP_N_DOWN: enter a string:" GET mvar PICTURE up_n_down(@mvar)
      READ
      set cursor off
      mvar = 0.00
      @ 15, 18 SAY "CALC_PIC: enter a number:" GET mvar PICTURE calc_pic(@mvar, '########.##')
      READ
      byebyebox(dumbo)


   CASE sel=12
      @ 0,0,24,79 box REPLICATE(CHR(250),9)
      temp = savescreen(0, 0, 24, 79)
      SETCOLOR('RB/N')
      shadowbox(10, 06, 14, 72, 2, 'Interactive Color Palette')
      SETCOLOR('+GR/N')
      Spread('If Michelango were alive today, he would get a kick out of this',11,20)
      Spread('interactive color palette!  Plug it instantly into your program',12,20)
      Spread('for maximum color flexibility. Try changing the screen with it!',13,20)
      INKEY(4)
      restscreen(0, 0, 24, 79, temp)
      COLORPAL(SETCOLOR(), 0, 0, 'coolscrn()')

   CASE sel=13
      exit
   ENDCASE
   RESTSCREEN(0,0,24,79,mainmenu)
ENDDO
RETURN

FUNC coolscrn
@ 0,0,24,79 box REPLICATE(CHR(250),9)
RETURN .T.

FUNCTION rollup
PARAM mtext
SCROLL(2, 8, 22, 71, 1)
@ 22,08 SAY strpad(mtext,64)
FOR xx = 1 TO 35
NEXT
RETURN ("")
