*:*********************************************************************
*:
*:        Program: DATEWORD()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 01/03/89     15:26
*:
*:  Returns verbose date (e.g., 'December 25, 1988')
*:
*:     Documented: 01/03/89 at 16:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION DateWord
PARAM mdate
mdate = IF(PCOUNT()=0, DATE(), mdate)  && use system date if no date passed
IF TYPE('mdate') = 'C'                 && convert char string to date
   mdate = CTOD(mdate)
ENDIF
RETURN (CMONTH(mdate) + ' ' + LTRIM(STR(day(mdate))) + ', ' + ;
        LTRIM(STR(YEAR(mdate))))

* end function DateWord()
*--------------------------------------------------------------------*

* eof $datewor.prg
