*:*********************************************************************
*:
*:        Program: $FIRSTCA.PRG
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1989, Greg Lief
*:  Last modified: 12/23/89 - expanded logic to test for punctuation,
*:                            as well as occurrences of "Mac" and "Mc"
*:
*:  Procs & Fncts: FIRSTCAP()
*:
*:*********************************************************************
FUNCTION FirstCap
PARAM mstring
PRIVATE mlength, xx
mlength = LEN(TRIM(mstring))
** make first character upper-case and all others lower-case
mstring = UPPER(SUBSTR(mstring,1,1)) + LOWER(SUBSTR(mstring,2))
FOR xx = 2 TO mlength - 1
   *** test for punctuation, space, "Mac" or "Mc"
   IF SUBSTR(mstring, xx, 1) $ ". '-/,&*(+\" .OR. ;
         (xx > 2 .AND. SUBSTR(mstring, xx - 2, 3) = "Mac") .OR. ;
         SUBSTR(mstring, xx - 1, 2) = "Mc"
      mstring = SUBSTR(mstring, 1, xx) + UPPER(SUBSTR(mstring, xx+1, 1)) + ;
                SUBSTR(mstring, xx+2)
   ENDIF
NEXT
RETURN (mstring)

* end function FirstCap()
*--------------------------------------------------------------------*

* eof $firstca.prg
