*:*********************************************************************
*:
*:        Program: PASS_CHK()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 02/06/89 - changed SET COLOR to SETCOLOR()
*:
*:      Generic password checking utility
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION Pass_chk
PARAMETERS password, mrow
* Parameters:  Password (I would suggest you pass this char by char)
*              Row # for message (optional, default 12)
PRIVATE mpass, oldscrn, oldcolor, wid, ret_val
ret_val = .T.
* check for valid row number
IF PCOUNT() = 1
   mrow = 12
ELSEIF mrow < 1 .OR. mrow > 22    && invalid row
   RETURN .F.
ENDIF
oldcolor = SETCOLOR('+W/R, N/N')
mpass = SPACE(LEN(password))
wid = INT((76 - (16 + LEN(mpass))) / 2)
oldscrn = shadowbox(mrow - 1, wid, mrow + 1, 79-wid, 4)
@ mrow, wid + 2   SAY 'Enter password:'
@ mrow, COL() + 1 GET mpass
READ
ByeByeBox(oldscrn)
SETCOLOR(oldcolor)
ret_val = (UPPER(mpass) == UPPER(password))
IF ! ret_val
   Err_msg('Invalid password')
ENDIF
RETURN (ret_val)

* end function Pass_Chk()
*--------------------------------------------------------------------*

* eof $passchk.prg
