*:*********************************************************************
*:
*:        Program: SPREAD()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 09/15/88     17:49
*:
*:     Displays a character string from the center out
*:
*:     Documented: 12/26/88 at 18:05                SNAP! version 3.10
*:*********************************************************************
FUNCTION Spread
PARAM msg, row, delay, mid
*-----------------------------------------------------------------
*  MSG   = message to display
*  ROW   = row at which to display message
*  DELAY = delay for spread effect (optional, default is 8)
*  MID   = column at which to begin spread (optional, default 40)
*-----------------------------------------------------------------
delay = IF(PCOUNT() < 3, 8, delay)
mid = IF(PCOUNT() < 4, 40, mid)
PRIVATE mlen, mloop, msg2, xx
msg2 = ''
mlen = LEN(msg)
FOR mloop = 1 TO INT(mlen/2)
   msg2 = SUBSTR(msg, 1, mloop) + SUBSTR(msg, mlen + 1 - mloop, mloop)
   @ row, mid-mloop SAY msg2
   FOR xx = 1 TO delay
   NEXT
NEXT
IF mlen%2 = 1
   @ row, mid-mloop SAY msg
ENDIF
RETURN []

* end function Spread()
*--------------------------------------------------------------------*

* eof $spread.prg
