*:*********************************************************************
*:
*:        Program: TIMEWORD()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 10/22/88     11:19
*:
*:  Returns time of day (Morning, Afternoon, Evening)
*:              12:00 am - 11:59 am = Morning
*:              12:00 pm -  5:59 pm = Afternoon
*:               6:00 pm - 11:59 pm = Evening
*:
*:*********************************************************************
FUNCTION Timeword
RETURN (IF(SECONDS() < 43200, 'Morning', ;
   IF(SECONDS() < 64800, 'Afternoon', 'Evening')))

* eof $timewor.prg
