***********************************************************
*
*   Function: WORLDUPPER()
*   Author:   Greg Lief
*   Copyright (c) 1990 Greg Lief
*   Dialect:  Summer '87
*   Syntax:   WorldUpper(<string to convert>)
*   Returns:  Character string converted to uppercase
*   Modified: 04/15/91 -- added support for '' and ''
*             special characters (thanks to Morten Ross)
*
***********************************************************
function worldupper
parameter mstring
private x, mchr, ret_val
ret_val = []
for x = 1 to len(mstring)
   mchr = asc(substr(mstring, x, 1))
   do case
      *** lower-case letter key
      case mchr > 96 .and. mchr < 123
         ret_val = ret_val + chr(mchr - 32)

      case mchr = 129
         ret_val = ret_val + chr(154)

      case mchr = 130
         ret_val = ret_val + chr(144)

      case mchr = 132
         ret_val = ret_val + chr(142)

      case mchr = 134
         ret_val = ret_val + chr(143)

      case mchr = 135
         ret_val = ret_val + chr(128)

      case mchr = 145
         ret_val = ret_val + chr(146)

      case mchr = 148
         ret_val = ret_val + chr(153)

      case mchr = 164
         ret_val = ret_val + chr(165)

      case mchr = 237
         ret_val = ret_val + chr(233)

      otherwise
         ret_val = ret_val + chr(mchr)

   endcase
next
return ret_val
