;
;     BLINKBIT() - turn blink bit on or off
;
;     Syntax: BLINKBIT(<logical>)
;
;             .T. = use blinking    .F. = use enhanced background characters
;
;     Return Value: None
;
;     Assembled with Microsoft MASM 4.0
;
;     Written by Greg Lief 08/07/90
;     not exactly original, but what the hell... all the good ideas are taken!
;

  INCLUDE c:\CLIPPER\EXTENDA.INC
  Name                 BLINK
  Public               BLINKBIT
  Extrn                __Parl:Far
  Extrn                __ret:far

  DGROUP GROUP         DATASG
  DATASG SEGMENT       PUBLIC '_DATA'

  Blinkit              DB         ?

  DATASG               ENDS

  _PROG                SEGMENT  'CODE'
                       ASSUME     CS:_PROG,DS:DGROUP,ES:DGROUP


  BLINKBIT             PROC       FAR

;------------------- Save Current Registers ----------------------
                       PUSH       BP
                       MOV        BP,SP
                       PUSH       DS
                       PUSH       ES
                       PUSH       SI
                       PUSH       DI

;------------------- Grab the Parameter ----------------------
                       Mov        AX,01           ; here it lies
                       Push       AX
                       Call       __PARL
                       Add        SP,2            ; Fix up stack
;                       Mov        Blinkit,AL      ; Save Value

;----------------------------  BIOS call --------------------------
                       MOV BL, AL
                       MOV AL, 03H          ;  Background intensity subservice
                       MOV AH, 10H          ;  Video BIOS request
                       INT 10H              ;  Boom

;----------------------  restore registers ------------------------
                       Pop        DI
                       Pop        SI
                       Pop        ES
                       Pop        DS
                       Pop        BP
                       call       __ret
                       Ret

  BLINKBIT             Endp
  _Prog                Ends
                       End
