*:*********************************************************************
*:
*:        Program: ADD_REC()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:  Last modified: 10/29/88     19:44
*:
*:     Attempts to APPEND BLANK in multi-user environment
*:
*:     Documented: 12/26/88 at 18:04                SNAP! version 3.10
*:*********************************************************************
FUNCTION Add_rec
PARAM waittime
PRIVATE waitcond, start
IF LEN(ALIAS()) = 0    && no database in use
   RETURN (.F.)
ENDIF
APPEND BLANK
IF ! NETERR()
   RETURN (.T.)
ELSE
   *  establish condition to wait for record to be appended
   *  if user passed parameter, use that as number of seconds to wait;
      *  otherwise, wait until the user presses the Esc key
   waitcond = IF(PCOUNT()=0, 'lastkey() != 27', 'seconds()-start < waittime')
   start = SECONDS()
   DO WHILE &waitcond
      APPEND BLANK
      IF ! NETERR()
         RETURN(.T.)
      ENDIF
   ENDDO
   Err_msg('Cannot add record at this time')
ENDIF
RETURN(.F.)

* end function Add_Rec()
*--------------------------------------------------------------------*

* eof $addrec.prg
