**********************************************************************
*
*       Function: FadeOut()
*
*         System: GRUMPFISH LIBRARY
*         Author: Greg Lief
*      Copyright (c) 1988-90, Greg Lief
*
*       Syntax: FadeOut(<filename>)
*
*    Parameter: <filename> is a character string representing the name
*               of the file in which the random coordinates were saved.
*
*      Returns: Nada
*
*!*********************************************************************
FUNCTION FadeOut
PARAMETER fname
PRIVATE handle, mrow, mcol, xx, ret_val
handle = FOPEN(fname)
ret_val = .F.
IF handle > -1
   ret_val = .T.
   STORE chr(32) to mrow, mcol
   FOR xx = 1 TO 2000
      FREAD(handle, @mrow, 1)
      FREAD(handle, @mcol, 1)
      @ ASC(mrow), ASC(mcol) SAY ' '
   NEXT
   FCLOSE(handle)
ENDIF
RETURN ret_val

* end function FadeOut()
*--------------------------------------------------------------------*

* eof $fadeout.prg
