*:*********************************************************************
*:
*:        Program: GFRAND()
*:
*:         System: GRUMPFISH LIBRARY
*:         Author: Greg Lief
*:      Copyright (c) 1988, Greg Lief
*:      With help from Jeff Wilson!!!
*:  Last modified: 01/13/89     15:47
*:
*:  Random number generator
*:
*:     Documented: 01/13/89 at 16:05                SNAP! version 3.10
*:*********************************************************************
* Parameter: any integer numeric expression
* Returns:   an integer in the range of 0 to n-1
FUNCTION GFRand
PARAM N
IF TYPE('xrndseed')=='U'
   PUBLIC xrndseed
   xrndseed = .123456789 + VAL(SUBSTR(TIME(),7,2))/100
ENDIF
xrndseed = (xrndseed * 31415821 + 1) / 1000000
xrndseed = xrndseed - INT(xrndseed)
RETURN INT(xrndseed * N)

* end function GFRand()
*--------------------------------------------------------------------*

* eof $rand.prg
