**********************************************************************
*
*        Program: RANDFILE()
*
*         System: GRUMPFISH LIBRARY
*         Author: Greg Lief
*      Copyright (c) 1988-89, Greg Lief
*
*  Returns a random file handle - great for creating temporary
*  files in multi-user systems
*
*  Syntax:  RandFile(<filename>)
*
*  Parameter: <filename> = character string representing name
*                          of existing .dbf (MUST EXIST ALREADY!!)
*
*  Returns: character string representing random filename
*
*:*********************************************************************
FUNCTION RandFile
PARAMETER mfile
DO WHILE FILE(mfile + '.dbf')
   mfile = "$$$" + LTRIM(STR(gfrand(99998) + 1))
ENDDO
RETURN mfile

* end function RandFile()
*--------------------------------------------------------------------*

* eof $randfil.prg
