**********************************************************************
*
*       Function: Sv_FadeIn()
*
*         System: GRUMPFISH LIBRARY
*         Author: Greg Lief
*      Copyright (c) 1988-90, Greg Lief
*
*       Syntax: Sv_FadeIn(<filename>)
*
*    Parameter: <filename> is a character string representing the name
*               of file in which to save the hacked up screen.
*
*      Returns: Nothing worth writing home about
*
*!*********************************************************************
FUNCTION Sv_FadeIn
PARAMETER fname
PRIVATE a[2000], cnt, buffer, x, row, col
SET PRINTER TO (fname)
SET PRINT ON
SET CONS OFF
AFILL(a, 0)
cnt = 0
DO WHILE cnt < 2000
   x = GFRand(2000)
   IF a[x+1] = 0
      a[x+1] = 1
      row = int(x / 80)
      col = int(x % 80)
      buffer = SAVESCREEN(row, col, row, col)
      ?? CHR(row) + CHR(col) + buffer
      cnt = cnt + 1
   ENDIF
ENDDO
SET PRINTER TO
SET PRINT OFF
SET CONS ON
RETURN []

* end function Sv_FadeIn()
*--------------------------------------------------------------------*

* eof $svfadei.prg
