**********************************************************************
*
*       Function: Sv_FadeOut()
*
*         System: GRUMPFISH LIBRARY
*         Author: Greg Lief
*      Copyright (c) 1988-90, Greg Lief
*
*       Syntax: Sv_FadeOut(<filename>)
*
*    Parameter: <filename> is a character string representing the name
*               of file in which to save the random coordinates.
*
*      Returns: Nada
*
*!*********************************************************************
FUNCTION Sv_FadeOut
PARAMETER fname
PRIVATE a[2000], cnt, x, mrow, mcol
SET PRINTER TO (fname)
SET PRINT ON
SET CONS OFF
AFILL(a, 0)
cnt = 0
DO WHILE cnt < 2000
   x = gfrand(2000)
   IF a[x+1] = 0
      a[x+1] = 1
      mrow = INT(x / 80)
      mcol = INT(x % 80)
      ?? CHR(mrow) + CHR(mcol)
      cnt = cnt + 1
   ENDIF
ENDDO
SET PRINTER TO
SET PRINT OFF
SET CONS ON
RETURN []

* end function Sv_FadeOut()
*--------------------------------------------------------------------*

* eof: $svfadeo.prg
