**    VSCRNSCRL()
**    Displays a screen with vertical scrolling
**    Grumpfish Library
**    Copyright (c) 1988-90 Greg Lief
**    Syntax: VSCRNSCRL(<screen file>)
**            Displays screen from left to right (screen must be pre-saved to
**            <screen file> using HBlindSave())
**
FUNCTION vscrnscrl
PARAMETER mfile
PRIVATE handle, screen_[25], buffer, xx, yy
IF FILE(mfile)
   buffer = SPACE(160)
   handle = FOPEN(mfile)
   FOR xx = 1 TO 25
      FREAD(handle, @buffer, 160)
      screen_[xx] = SUBSTR(buffer, 1, 160)
   NEXT
   FCLOSE(handle)
   FOR xx = 25 TO 1 STEP -1
      SCROLL(0, 0, 24, 79, -1)
      RESTSCREEN(0, 0,  0, 79, screen_[xx])
   NEXT
ENDIF
RETURN []

* end function VScrnScrl()
*--------------------------------------------------------------------*

* eof $vscroll.prg
